<template>
  <div
    v-if="gameEntries.length > 0"
    :class="[
      'grid w-full my-10 grid-cols-2',
      isLiveCasinoEnabled
        ? 'gap-x-4 gap-y-6 sm:grid-cols-3 lg:grid-cols-4'
        : 'gap-4',
    ]"
  >
    <template v-for="game in gameEntries" :key="game.GameId">
      <lobby-black-horizontal-game-entry
        v-if="isLiveCasinoEnabled"
        :game="game"
        @onClick="handleGameSelected(game.GameId)"
      />
      <lobby-black-vertical-game-entry
        v-else
        :game="game"
        @onClick="handleGameSelected(game.GameId)"
      />
    </template>
  </div>
  <lobby-no-game-message v-else />
</template>
<script lang="ts">
import { defineComponent, computed, ref } from "vue";
import _ from "lodash";
import { store } from "@/store";
import {
  handleGameEntryOpenWindow,
  useGameEntryBaseOnTabSelected,
} from "@/composables/useTheme";
import EnumEntranceLocation from "@/models/enums/enumEntranceLocation";

export default defineComponent({
  name: "GameListEntryComponent",
  setup() {
    const route = useRoute();
    const router = useRouter();
    const authenticated = computed(() => store.state.auth);
    const isGameLoading = computed(() => store.state.isGameUpdateLoading);
    const {
      gameEntrySelected,
      customizeObjectCasinos,
      customizeObjectVirtuals,
      customizeObjectKeno,
      customizeObjectPoker,
      customizeObjectLottery,
    } = useGameEntryBaseOnTabSelected();
    const tabTypeForRoute = computed(() => {
      let result = "";
      gameEntrySelected.value.forEach((item) => {
        result = item?.TabType.replaceAll(" ", "-").toLowerCase();
      });
      return result === ""
        ? `?entrance=${EnumEntranceLocation.GameLobby}`
        : `?tab=${result}&entrance=${EnumEntranceLocation.GameLobby}`;
    });
    const selectedTheme = computed((): string => store.state.selectedThemeName);
    const isLiveCasinoEnabled = computed((): boolean =>
      !_.isEmpty(gameEntrySelected.value)
        ? gameEntrySelected.value[0].Category === 2
        : false
    );
    const gameEntries = computed(() => {
      // if (isLiveCasinoEnabled.value && selectedTheme.value === "black") {
      //   return customizeObjectCasinos.value;
      // }
      if (route.name === "virtual-sports" && selectedTheme.value === "black") {
        return customizeObjectVirtuals.value;
      }
      if (route.name === "keno" && selectedTheme.value === "black") {
        return customizeObjectKeno.value;
      }
      if (route.name === "poker" && selectedTheme.value === "black") {
        return customizeObjectPoker.value;
      }
      return gameEntrySelected.value;
    });
    const dialog = ref(false);
    const handleGameSelected = (GameId: number) => {
      if (authenticated.value) {
        router.push(`/game/${GameId}${tabTypeForRoute.value}`);
      } else {
        router.push("/login");
      }
    };
    return {
      authenticated,
      isGameLoading,
      gameEntrySelected,
      customizeObjectCasinos,
      handleGameEntryOpenWindow,
      EnumEntranceLocation,
      tabTypeForRoute,
      selectedTheme,
      gameEntries,
      dialog,
      handleGameSelected,
      isLiveCasinoEnabled,
    };
  },
});
</script>
<style scoped></style>
